var qs = require('qs')

export default {
  wRequest: async function (url, obj, params) {
    if (params !== undefined) {
      let param = qs.stringify(params)
      let result = await obj.$axios.$post(url, param)
      // console.log('test api3 == ' + JSON.stringify(result) + 'result type ==== ' + typeof result)
      return result
    }
    let result = await obj.$axios.$post(url)
    // console.log('test api1 == ' + JSON.stringify(result) + 'result type ==== ' + typeof result)
    return result
  },
  getRequest: async function (url, obj, params) {
    if (params !== undefined) {
      let param = qs.stringify(params)
      let result = await obj.$axios.$get(url, param)
      // console.log('test api1 == ' + JSON.stringify(result.data))
      return result
    }
    let result = await obj.$axios.$get(url)
    // console.log('test api2 == ' + JSON.stringify(result.data))
    return result
  },
  postByJson: async function (url, obj, params) {
    // json格式的网络请求，需要指定content-type，并且参数不能用qs转化成key=value的形式，直接以json对象传递就可以
    let result = await obj.$axios({
      headers: {
        'Content-Type': 'application/json'
      },
      method: 'post',
      url: url,
      data: params
    })
    return result // 返回数据的异常
  },
  // 开始定时器
  startTimer(obj) {
    let that = obj
    const TIME_COUNT = 60
    if (!obj.timer) {
      obj.count = TIME_COUNT
      obj.timer = setInterval(() => {
        if (that.count > 0 && that.count <= TIME_COUNT) {
          that.count--
          that.btnText = '已发送(' + that.count + ')'
        } else {
          clearInterval(that.timer)
          that.timer = null
          that.btnText = '重新发送'
          that.btnDisable = false
        }
      }, 1000)
    }
  },
  // 验证手机号码
  identyTelNumber(tel) {
    if (tel === undefined || tel === null || tel === '') {
      return false
    }
    var reg = 11 && /^((13|14|15|17|18)[0-9]{1}\d{8})$/
    if (!reg.test(tel)) {
      return false
    }
    return true
  },
  // 验证中文字符
  hasChinese(checkStr) {
    var reg = /[\u4E00-\u9FA5]/g
    if (reg.test(checkStr)) {
      return false
    }
    return true
  },
  identyEmail(email) {
    if (email === undefined || email === '') {
      alert('请输入邮箱')
      return false
    }
    var reg = /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/ // eslint-disable-line no-useless-escape
    if (!reg.test(email)) {
      alert('请输入正确的邮箱')
      return false
    }
    return true
  },
  // 获取搜索页头部列表
  searchGoods(obj, param) { return this.wRequest('/xhr/goods/search', obj, param) },
  // 获取订单列表
  getOrderList(obj, param) { return this.wRequest('/xhr/order/searchList.json', obj, param) },
  // 获取所有订单页面，广州二次支付订单导入按钮是否显示
  orderPageBtnShow(obj) { return this.wRequest('/xhr/order/orderPageStatus.json', obj) },
  // 获取未支付订单列表
  getUnpaylist(obj, param) { return this.wRequest('/xhr/order/unpaidOrderList.json', obj, param) },
  // 获取选中未支付订单，应支付金额明细
  getUnpayAmount(obj, param) { return this.wRequest('/xhr/order/neddedFees.json', obj, param) },
  // 获取需要编辑的订单的地址信息
  editOrderAddress(obj, param) { return this.wRequest('/xhr/order/getOrderAddress.json', obj, param) },
  // 保存编辑的订单的地址信息
  saveOrderAddr(obj, param) { return this.wRequest('/xhr/order/orderAddressUpdate.json', obj, param) },
  // 获取购物车列表
  getCartlist(obj, param) { return this.postByJson('/xhr/cart/list.json', obj, param) },
  // 更改购物车数量
  changeNumInCart(obj, param) { return this.wRequest('/xhr/cart/updateById.json', obj, param) },
  // 添加到购物车
  addGoodToCart(obj, param) { return this.wRequest('/xhr/cart/addCartByCode.json', obj, param) },
  // 获取购物车数量
  cartGoodNum(obj) { return this.wRequest('/xhr/cart/getCount.json', obj) },
  // 删除购物车商品
  delCartGoods(obj, param) { return this.wRequest('/xhr/cart/deleteById.json', obj, param) },
  // 获取头部类目列表
  getClassify(obj) { return this.wRequest('/xhr/category/all.json', obj) },
  // 获取商品详情
  getGoodsDetail(obj, goodCode) { return this.wRequest('/xhr/goods/' + goodCode + '.json', obj) },
  // 商品详情推荐商品
  detailHotGoods(obj) { return this.wRequest('/xhr/goods/recommend.json', obj) },
  // 获取首页内容
  getIndexGoods(obj) { return this.wRequest('/xhr/goods/indexGoods', obj) },
  getAddressById(obj, param) { return this.wRequest('/xhr/area/child.json', obj, param) },
  // 获取平台分销列表
  getPlatformList(obj, param) { return this.wRequest('/xhr/financial/orderPackageList/queryByPage.json', obj, param) },
  // 获取采购财务列表
  getPurchaseList(obj, param) { return this.wRequest('/xhr/report/purchaseFinancial.json', obj, param) },
  // 获取供货财务列表
  getSupplyList(obj, param) { return this.wRequest('/xhr/report/supplyFinancial.json', obj, param) },
  // 取消订单
  cancelOrder(obj, param) { return this.wRequest('/xhr/order/orderCancel', obj, param) },
  // 删除订单
  deleteOrder(obj, param) { return this.wRequest('/xhr/order/orderDelete.json', obj, param) },
  // 订单详情获取商品和订单编号等
  orderDetailInfo(obj, param) { return this.wRequest('/xhr/order/detail.json', obj, param) },
  // 订单详情-获取海关状态
  orderCustomSts(obj, param) { return this.wRequest('/xhr/order/packageCustomsLog.json', obj, param) },
  // 修改身份证号
  changePaper(obj, param) { return this.wRequest('/xhr/order/changePaper.json', obj, param) },
  // 获取确认订单页面商品信息
  getConfirmOrder(obj) { return this.wRequest('/xhr/order/confirmOrder', obj) },
  // 获取用户地址列表
  addressListGet(obj) { return this.wRequest('/xhr/userAddress/list.json', obj) },
  // 设置为用户默认地址
  setAddrDefault(obj, param) { return this.wRequest('/xhr/userAddress/setDefault.json', obj, param) },
  // 删除用户地址
  delUserAddr(obj, param) { return this.wRequest('/xhr/userAddress/delete.json', obj, param) },
  // 根据地址id获取单个地址详细信息
  getAddrFullById(obj, param) { return this.wRequest('/xhr/userAddress/getById.json', obj, param) },
  // 添加或者修改地址
  updateAddrById(obj, param) { return this.wRequest('/xhr/userAddress/upsert.json', obj, param) },
  // 地址-添加身份证
  addIdentityNumber(obj, param) { return this.wRequest('/xhr/userAddress/addIdentityNumber.json', obj, param) },
  // 提交订单
  submitOrder(obj, param) { return this.postByJson('/xhr/order/submitOrder2.json', obj, param) },
  // 去支付页面获取可使用支付方式和收款方信息
  goPayInfo(obj, param) { return this.wRequest('/xhr/pay/payWay.json', obj, param) },
  // 支付(包含单个订单直接付款和未支付订单页面整体提交)
  ordersPay(obj, param) { return this.wRequest('/xhr/pay/payment.json', obj, param) },
  // 获取账户明细列表
  getFinanceDetail(obj, param) { return this.wRequest('/xhr/financial/accountDetail/queryByPage.json', obj, param) },
  // 获取余额提现列表
  getwithdrawList(obj) { return this.wRequest('/xhr/finance/withdrawList', obj) },
  // 获取自有货源列表
  getSourceList(obj, param) { return this.wRequest('/xhr/goods/supplierSearch.json', obj, param) },
  // 获取库存变动列表
  getInventoryList(obj, param) { return this.wRequest('/xhr/goods/inventoryLogSum.json', obj, param) },
  // 获取库存变动详情
  getInventoryDetail(obj, param) { return this.wRequest('/xhr/goods/inventoryLog.json', obj, param) },
  // 库存变动详情导出
  InventoryExport(obj, param) { return this.wRequest('/xhr/goods/exportInventoryLog', obj, param) },
  // 登录页面相关
  usrLogin(obj, param) { return this.wRequest('/xhr/login/submit.json', obj, param) },
  // 退出登录
  usrLogout(obj) { return this.wRequest('/xhr/login/logout.json', obj) },
  placeOrderInfo(obj, param) { return this.postByJson('/xhr/order/initOrder2.json', obj, param) },
  // 获取包裹状态
  getPackageType(obj) { return this.wRequest('/xhr/order/packageStatus.json', obj) },
  // 获取海关状态
  getCustomType(obj) { return this.wRequest('/xhr/order/customsStatus.json', obj) },
  // 快递接口
  getExpress(obj, param) { return this.wRequest('/xhr/order/getPackageExpInfo.json', obj, param) },
  // 手机验证码(注册用)
  getMobileCode(obj, param) { return this.wRequest('/xhr/login/mobileCode', obj, param) },
  // 注册
  register(obj, param) { return this.wRequest('/xhr/login/register', obj, param) },
  // 获取用户信息
  getUserInfo(obj) { return this.wRequest('/xhr/web/user/getInfo', obj) },
  // 手机验证码(修改手机号、修改密码用)
  getChangeMobileCode(obj, param) { return this.wRequest('/xhr/findPassword/getMobileCode.json', obj, param) },
  // 确认输入的验证码是否正确(修改手机号、修改密码用)
  confirmMobileCode(obj, param) { return this.wRequest('/xhr/findPassword/verifyMobileCode.json', obj, param) },
  // 更新手机号码接口
  updateMobile(obj, param) { return this.wRequest('/xhr/web/user/updateMobile.json', obj, param) },
  // 更新用户名
  updateName(obj, param) { return this.wRequest('/xhr/web/user/updateName.json', obj, param) },
  // 修改用户密码
  changePassword(obj, param) { return this.wRequest('/xhr/login/changePassword', obj, param) },
  // 上传头像信息
  saveHeadr(obj, param) { return this.wRequest('/xhr/web/user/updateAvatar.json', obj, param) },
  // 找回密码（第一步）：账号验证
  verifyAccount(obj, param) { return this.wRequest('/xhr/findPassword/verifyAccount.json', obj, param) },
  // 找回密码（第三步）:手机验证码修改密码
  retrievePassword(obj, param) { return this.wRequest('/xhr/findPassword/retrievePw.json', obj, param) },
  // 找回密码（第二步）：发送邮件
  sendEmail(obj, param) { return this.wRequest('/xhr/findPassword/sendEmail.json', obj, param) },
  // 找回密码（第三步）：邮件验证
  verifyEmail(obj, param) { return this.wRequest('/xhr/findPassword/verifyEmail.json', obj, param) },
  // 仓库列表
  depotList(obj) { return this.wRequest('/xhr/depot/list.json', obj) },
  // 供应商自有货源导出
  sourceExport(obj, param) { return this.wRequest('/xhr/goods/selfGoodsDerive.json', obj, param) },
  // 批量提货即批量添加购物车
  addCartBatch(obj, param) { return this.postByJson('/xhr/cart/addCartBatch', obj, param) },
  // 用户余额信息
  moneyInfo(obj) { return this.wRequest('/xhr/financial/moneyInfo.json', obj) },
  // 余额充值
  recharge(obj, param) { return this.wRequest('/xhr/order/recharge.json', obj, param) },
  // 售后申请页面初始化数据
  afterSaleInit(obj, param) { return this.wRequest('/xhr/order/afterSale/applyDetail.json', obj, param) },
  // 售后申请提交
  afterSaleSubmit(obj, param) { return this.wRequest('/xhr/order/afterSale/applySubmit.json', obj, param) },
  // 售后详情
  afterSaleDetail(obj, param) { return this.wRequest('/xhr/order/afterSale/detail.json', obj, param) },
  // 提交售后发货信息
  afterSaleSubmitLogis(obj, param) { return this.wRequest('/xhr/order/afterSale/deliverySubmit.json', obj, param) },
  // 售后申请取消
  afterSalecancel(obj, param) { return this.wRequest('/xhr/order/afterSale/applyCancel.json', obj, param) },
  // 提现页面-提现提交
  withdrawCash(obj, param) { return this.wRequest('/cashWithdraw/confirm.json', obj, param) },
  // 获取订单数量
  getSearchCount(obj, param) { return this.wRequest('/xhr/order/searchCount.json', obj, param) },
  // 获取支付信息
  getPayInfo(obj) { return this.wRequest('/mock/47/api/shop/profile/pay/list', obj) },
  server_getConfig(key) {
    if (process.env.WD_ENV === 'production') {
      var configp = require('../config/config-prod.json')
      return configp[key]
    } else if (process.env.WD_ENV === 'test') {
      var configt = require('../config/config-test.json')
      return configt[key]
    }
    var configdev = require('../config/config-dev.json')
    return configdev[key]
  },
  client_getConfig(key) {
    if (window.location.href.indexOf('m.yang800.com') !== -1) {
      var configp = require('../config/config-prod.json')
      return configp[key]
    } else if (window.location.href.indexOf('mtest.yang800.cn') !== -1) {
      var configt = require('../config/config-test.json')
      return configt[key]
    }
    var configdev = require('../config/config-dev.json')
    return configdev[key]
  }
}
